<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [leftTemplate]="leftTemplate"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #leftTemplate>
    <solidify-image-upload-wrapper-container [defaultIcon]="iconNameEnum.institutions"
                                             [resourceFileNameSpace]="adminInstitutionActionNameSpace"
                                             [resourceFileState]="$any(adminInstitutionState)"
                                             [uploadInstantly]="false"
                                             [isEditable]="(model | isNullOrUndefined) || editAvailable"
                                             (logoChange)="logoChange($event)"
    ></solidify-image-upload-wrapper-container>
  </ng-template>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate }}</mat-label>
      <input (blur)="checkAvailable(formDefinition.name, fd)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             autofocus
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate }}</mat-label>
      <textarea [formControl]="fd"
                [required]="formValidationHelper.hasRequiredField(fd)"
                [solidifyValidation]="errors"
                cdkAutosizeMaxRows="10"
                cdkAutosizeMinRows="5"
                cdkTextareaAutosize
                matInput
      >
    </textarea>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <solidify-url-input-navigator *ngIf="getFormControl(formDefinition.url) as fd"
                                  [formControl]="fd"
    >
    </solidify-url-input-navigator>

  </ng-template>

  <ng-template #rightTemplate>

    <solidify-keyword-input *ngIf="getFormControl(formDefinition.emailSuffixes) as fd"
                            [formControl]="fd"
                            [placeholderToTranslate]="labelTranslateEnum.emailSuffixes | translate"
                            [readonly]="readonly"
    >
    </solidify-keyword-input>

    <mat-form-field *ngIf="getFormControl(formDefinition.rorId) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.rorId | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <dlcm-shared-identifiers *ngIf="model?.identifiers as identifiers"
                             [identifiers]="identifiers"
    ></dlcm-shared-identifiers>

  </ng-template>

  <dlcm-shared-table-person-role-container [formControl]="getFormControl(formDefinition.personRole)"
                                           [listRole]="listRole"
                                           [readonly]="readonly"
                                           [selectedResourceRole]="selectedPersonRole"
                                           [isWithLinkToAdmin]="securityService.isRootOrAdmin()"
                                           [preventEdition]="!editAvailable"
                                           (navigate)="navigate($event)"
  ></dlcm-shared-table-person-role-container>

  <dlcm-shared-table-orgunit-container *ngIf="getFormControl(formDefinition.orgUnit) as fd"
                                       [formControl]="fd"
                                       [readonly]="readonly"
                                       [selectedOrgUnit]="listOrgUnits"
                                       [preventEdition]="!editAvailable"
                                       [isWithLinkToAdmin]="securityService.isRootOrAdmin()"
                                       (navigate)="navigate($event)"
  ></dlcm-shared-table-orgunit-container>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>

</form>
